/*
    <Extrae informacion de dispositivos conectados al sistema>
    Copyright (C) <2011>  <José Antonio Sánchez Reynaga>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "devices.h"


QMap <QString, Device> Devices::listAvaliableDevices()
{
    QMap <QString, Device> USBs;

    qDebug() << "******* LISTING STORAGE DRIVE";
    foreach(const Device &device, Device::listFromType(DeviceInterface::StorageDrive)){
        qDebug() << "DEVICE : " << device.product() << " - UDI : " << device.udi();
    }
    qDebug() << "********************************\n";
    
     qDebug() << "******* LISTING STORAGE VOLUMEN";
    foreach(const Device &device, Device::listFromType(DeviceInterface::StorageVolume)){
        qDebug() << "DEVICE : " << device.product() << " - UDI : " << device.udi();
    }
    qDebug() << "********************************\n";
    
        qDebug() << "******* LISTING STORAGE ACCESS";
    foreach(const Device &device, Device::listFromType(DeviceInterface::StorageAccess)){
        qDebug() << "DEVICE : " << device.product() << " - UDI : " << device.udi();
    }
    qDebug() << "********************************\n";
    
    qDebug() << "\n>> OBTAINING USBs *************";
    //Escogemos solo los dispositivos USB
    foreach(const Device &i, Device::listFromType(DeviceInterface::StorageAccess, QString())){
        
        if(i.parent().is<StorageDrive>()){
                qDebug() << i.udi() << " it is StorageDrive";
                
             if(i.parent().as<StorageDrive>()->bus() == StorageDrive::Usb){
//                USBs[i.as<Block>()->device()] = i;
                  qDebug() << "UDI: "<< i.udi() << "Dev Path : "  << i.as<Block>()->device() << "\n"; 
                  USBs.insert(i.as<Block>()->device(), i);
            }
        }
        
       
    }
    qDebug() << "*********************************\n"; 
    
    qDebug() << "****************** DETECTED USB DEVICES\n" <<
            USBs.keys()
            << "\n**********************************************";
    
    return USBs;
}


