/*
    <Ejecuta comandos para dar formato a los volumenes>
    Copyright (C) <2011>  <José Antonio Sánchez Reynaga>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "threadformat.h"

ThreadFormat::ThreadFormat(QObject* parent): QThread(parent)
{

}

ThreadFormat::~ThreadFormat()
{
    
}


void ThreadFormat::run()
{
    
    //Esto es para que le de tiempo a linux de para que desmonte el dispositivo
    QThread::sleep(4);
        
        
    //Argumentos para cada formato
    QStringList argumentos;
    
    //Validamos si la propiedad de sistema de archivos 
    if(filesystem.isEmpty()){
        qDebug() << "ERROR: Unknown filesystem :(";
        return;
    }
        
    //Validamos si existe el dispositivo
    if(dirDev.isEmpty()){
       qDebug() << "ERROR : Unknown volume to format";
       return;
    }
        
        
    //SOPORTE PARA NTFS
    if(filesystem == QString("ntfs")){
        
        
        
        qDebug() << "**** FORMATTING AS NTFS";
            
             //Validacion de las etiquetas
        if(label.isEmpty()){
             //Argumentos cuando tiene etiqueta
            argumentos << "-f" << "-v" << dirDev;
        }else{
             //Argumentos cuando tiene etiqueta
            argumentos << "-f" << "-L"  << label  << "-v" << dirDev;
        }
            
        qDebug() << "EXEC COMMANDS : " << "mkntfs" << argumentos;
        
        if(QProcess::execute("mkntfs", argumentos) == 0){
            qDebug() << "USB FORMATTED SUCCESSFULLY";
            ok = true;
        }else{
            qDebug() << "UNABLE TO FORMAT";
            ok = false;
        }
        return;
    }
    else if(filesystem == QString("fat32")){
        
        qDebug() << "**** FORMATTING AS FAT 32";
        
        //Validacion de las etiquetas
        if(label.isEmpty()){
             //Argumentos cuando tiene etiqueta
            argumentos << "-v" << dirDev;
        }else{
             //Argumentos cuando tiene etiqueta
            argumentos << "-n"  << (label).toUpper().mid(0, 11)  << "-v" << dirDev;
        }

        qDebug() << "EXEC COMMANDS : " << "mkdosfs" << argumentos;
        
        if(QProcess::execute("mkdosfs", argumentos) == 0){
            qDebug() << "USB FORMATTED SUCCESSFULLY";
            ok = true;
        }else{
            qDebug() << "UNABLE TO FORMAT";
            ok = false;
        }
        return;
    }
    else if(filesystem == QString("ext4")){
         qDebug() << "**** FORMATTING AS EXT4";
        
        
            
            
              //Validacion de las etiquetas
        if(label.isEmpty()){
             //Argumentos cuando tiene etiqueta
            argumentos << "-t" << "ext4" << "-v" << dirDev;
        }else{
             //Argumentos cuando tiene etiqueta
            argumentos << "-t" << "ext4" << "-L"  << (label).mid(0, 16) << "-v" << dirDev;
        }
            
        qDebug() << "EXEC COMMANDS : " << "mke2fs" << argumentos;
        
        if(QProcess::execute("mke2fs", argumentos) == 0){
            qDebug() << "USB FORMATTED SUCCESSFULLY";
            ok = true;
        }else{
            qDebug() << "UNABLE TO FORMAT";
            ok = false;
        }
        return;
    }else if(filesystem == QString("ext2")){
         qDebug() << "**** FORMATTING AS EXT2";
        
        
            
            
              //Validacion de las etiquetas
        if(label.isEmpty()){
             //Argumentos cuando tiene etiqueta
            argumentos << "-t" << "ext2" << "-v" << dirDev;
        }else{
             //Argumentos cuando tiene etiqueta
            argumentos << "-t" << "ext2" << "-L"  << (label).mid(0, 16) << "-v" << dirDev;
        }
            
        qDebug() << "EXEC COMMANDS : " << "mke2fs" << argumentos;
        
        if(QProcess::execute("mke2fs", argumentos) == 0){
            qDebug() << "USB FORMATTED SUCCESSFULLY";
            ok = true;
        }else{
            qDebug() << "UNABLE TO FORMAT";
            ok = false;
        }
        return;
    }else if(filesystem == QString("ext3")){
         qDebug() << "**** FORMATTING AS EXT3";
        
        
            
            
              //Validacion de las etiquetas
        if(label.isEmpty()){
             //Argumentos cuando tiene etiqueta
            argumentos << "-t" << "ext3" << "-v" << dirDev;
        }else{
             //Argumentos cuando tiene etiqueta
            argumentos << "-t" << "ext3" << "-L"  << (label).mid(0, 16) << "-v" << dirDev;
        }
            
        qDebug() << "EXEC COMMANDS : " << "mke2fs" << argumentos;
        
        if(QProcess::execute("mke2fs", argumentos) == 0){
            qDebug() << "USB FORMATTED SUCCESSGULLY";
            ok = true;
        }else{
            qDebug() << "UNABLE TO FORMAT";
            ok = false;
        }
        return;
    }
    else{
            qDebug() << "ERROR: Unsupported filesystem = " << filesystem;
            ok = false;
    }
    
}

void ThreadFormat::setLabel(QString lb)
{
    label = lb;
}


bool ThreadFormat::isOk()
{
    return ok;
}

void ThreadFormat::setFilesystem(QString fs)
{
    filesystem = fs;
}

void ThreadFormat::setDirDev(QString dir)
{
    dirDev = dir;
}



